package de.lmu.ifi.pst.x10080133;

import javax.swing.JOptionPane;

import com.nomagic.actions.ActionsCategory;
import com.nomagic.magicdraw.actions.ActionsConfiguratorsManager;
import com.nomagic.magicdraw.plugins.Plugin;

import de.lmu.ifi.pst.x10080133.action.GenerateMonitorFileAction;
import de.lmu.ifi.pst.x10080133.context.BrowserContextConfigurator;

/**
 * Base class for SecureNavigationPath - plugin MagicSNP
 * 4 debugging, debug MaigcPluginDebug project
 * 
 * @author Roman.Schwienbacher
 */
public class SNPPlugin extends Plugin {

	@Override
	public void init() {

		try {
			// Register Actions
			ActionsCategory category = new ActionsCategory(null, null);
			category.addAction(new GenerateMonitorFileAction());

			// Register Action in ConainmentBrowserContext
			ActionsConfiguratorsManager manager = ActionsConfiguratorsManager.getInstance();
			manager.addContainmentBrowserContextConfigurator(new BrowserContextConfigurator(category));		

		} catch (Exception _e) {
			JOptionPane.showMessageDialog(null, "Error loading MagicSNP: " + _e.getMessage());
		}
	}

	@Override
	public boolean close() {
		return true;
	}

	@Override
	public boolean isSupported() {
		return true;
	}
}
