package de.lmu.ifi.pst.x10080133.context;

import com.nomagic.actions.AMConfigurator;
import com.nomagic.actions.ActionsCategory;
import com.nomagic.actions.ActionsManager;
import com.nomagic.actions.NMAction;
import com.nomagic.magicdraw.actions.BrowserContextAMConfigurator;
import com.nomagic.magicdraw.actions.MDActionsCategory;
import com.nomagic.magicdraw.ui.browser.Tree;

/**
 * Extends MagicDraw context by SNP_PLUGIN_MENU_CATEGORY/SNP_PLUGIN_MENU_ID
 * 
 * @author Roman.Schwienbacher
 */
public class BrowserContextConfigurator implements BrowserContextAMConfigurator {

	public final static String SNP_PLUGIN_MENU_CATEGORY = "MagicSNP";
	public final static String SNP_PLUGIN_MENU_ID = "SNPPluginMenuID";

	private NMAction action;

	public BrowserContextConfigurator(NMAction nmAction) {
		this.action = nmAction;
	}

	@Override
	public int getPriority() {
		return AMConfigurator.MEDIUM_PRIORITY;
	}

	@Override
	public void configure(ActionsManager mgr, Tree tree) {

		// try to find the existing category
		ActionsCategory category = (ActionsCategory) mgr.getActionFor(SNP_PLUGIN_MENU_ID);

		// if it doesn't exist create
		if (category == null) {
			category = new MDActionsCategory(SNP_PLUGIN_MENU_ID, SNP_PLUGIN_MENU_CATEGORY);
			category.setNested(true);
			mgr.addCategory(category);
		}

		// then add the action to the category
		category.addAction(action);
	}

}
