package de.lmu.ifi.pst.x10080133.domain;

import com.google.gson.Gson;

/**
 * Base-Information holder for the Navigation-File security.properties, contains n locations (navigation nodes)
 * @author Roman.Schwienbacher
 */
public class NavigationFile {

	private String _comment;

	private String application;
	private NavigationNode[] locations;
	private String default_violation;

	public String get_comment() {
		return _comment;
	}

	public void set_comment(String _comment) {
		this._comment = _comment;
	}

	public String getApplication() {
		return application;
	}

	public void setApplication(String application) {
		this.application = application;
	}

	public NavigationNode[] getLocations() {
		return locations;
	}

	public void setLocations(NavigationNode[] locations) {
		this.locations = locations;
	}

	public String getDefault_violation() {
		return default_violation;
	}

	public void setDefault_violation(String default_violation) {
		this.default_violation = default_violation;
	}

	/**
	 * 
	 * @return JSON-String of this instance
	 */
	public String encodeToJSON() {

		String rtrn = "";

		try {
			rtrn = new Gson().toJson(this);
		} catch (Exception _e) {
			_e.printStackTrace();
		}

		return rtrn;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((application == null) ? 0 : application.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		NavigationFile other = (NavigationFile) obj;
		if (application == null) {
			if (other.application != null)
				return false;
		} else if (!application.equals(other.application))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "NavigationFile [application=" + application + "]";
	}

}
